Index: palm/trunk/SOURCE/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_gasphase_mod.f90	(revision 3799)
+++ palm/trunk/SOURCE/chem_gasphase_mod.f90	(revision 3820)
@@ -82,5 +82,5 @@
   PUBLIC :: chem_gasphase_integrate
   PUBLIC :: initialize_kpp_ctrl
-  PUBLIC :: get_mechanismname
+  PUBLIC :: get_mechanism_name
 
 ! END OF MODULE HEADER TEMPLATE
@@ -114,6 +114,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Parameters.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -191,6 +191,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Global.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -256,6 +256,6 @@
 ! 
 ! File                 : chem_gasphase_mod_JacobianSP.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -300,6 +300,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Monitor.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -362,6 +362,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Initialize.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -388,6 +388,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Integrator.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -446,6 +446,6 @@
 ! 
 ! File                 : chem_gasphase_mod_LinearAlgebra.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -473,6 +473,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Jacobian.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -500,6 +500,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Function.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -529,6 +529,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Rates.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -555,6 +555,6 @@
 ! 
 ! File                 : chem_gasphase_mod_Util.f90
-! Time                 : Fri Mar 15 16:28:29 2019
-! Working directory    : /home/forkel-r/palmstuff/work/trunk20190315/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
+! Time                 : Wed Mar 27 09:51:40 2019
+! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
 ! Output root filename : chem_gasphase_mod
@@ -662,7 +662,7 @@
   END INTERFACE        kppdecomp
  
-  INTERFACE            get_mechanismname
-    MODULE PROCEDURE   get_mechanismname
-  END INTERFACE        get_mechanismname
+  INTERFACE            get_mechanism_name
+    MODULE PROCEDURE   get_mechanism_name
+  END INTERFACE        get_mechanism_name
  
   INTERFACE            chem_gasphase_integrate
@@ -690,5 +690,5 @@
 !  
 ! Following line is just to avoid compiler message about unused variables
-IF ( lu_crow(1) == 1  .OR.  lu_icol(1) == 1  .OR.  lu_irow(1) == 1 )  CONTINUE 
+   IF ( lu_crow(1) == 1  .OR.  lu_icol(1) == 1  .OR.  lu_irow(1) == 1 )  CONTINUE 
 !  
 
@@ -778,5 +778,5 @@
 
 ! Following line is just to avoid compiler message about unused variables
-IF ( f(nfix) > 0.0_dp )  CONTINUE
+   IF ( f(nfix) > 0.0_dp )  CONTINUE
 !  
 ! Computation of equation rates
@@ -825,5 +825,5 @@
 !
 ! Following line is just to avoid compiler message about unused variables
-IF ( f(nfix) > 0.0_dp )  CONTINUE
+   IF ( f(nfix) > 0.0_dp )  CONTINUE
 
 ! B(1) = dA(1)/dV(3)
@@ -972,5 +972,5 @@
 !  
 ! Following line is just to avoid compiler message about unused variables
-IF ( incx == 0 )  CONTINUE
+   IF ( incx == 0 )  CONTINUE
 
       IF (alpha .eq. one)RETURN
@@ -1038,5 +1038,5 @@
 !  
 ! Following line is just to avoid compiler message about unused variables
-IF ( incx == 0  .OR.  incy == 0 )  CONTINUE
+   IF ( incx == 0  .OR.  incy == 0 )  CONTINUE
       IF (alpha .eq. zero)RETURN
       IF (n .le. 0)RETURN
@@ -1773,5 +1773,5 @@
 !  
 ! Following line is just to avoid compiler message about unused variables
-IF ( pivot(1) == 0 )  CONTINUE
+   IF ( pivot(1) == 0 )  CONTINUE
 
 #ifdef full_algebra    
@@ -2291,5 +2291,5 @@
   END SUBROUTINE kppdecomp                                            
  
-SUBROUTINE get_mechanismname                                        
+SUBROUTINE get_mechanism_name                                       
                                                                     
   IMPLICIT NONE                                                     
@@ -2299,5 +2299,5 @@
                                                                     
   RETURN                                                            
-END SUBROUTINE get_mechanismname                                    
+END SUBROUTINE get_mechanism_name                                   
                                                                     
  