Index: palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/chem_gasphase_mod.f90
===================================================================
--- palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/chem_gasphase_mod.f90	(revision 3820)
+++ palm/trunk/UTIL/chemistry/gasphase_preproc/mechanisms/def_cbm4/chem_gasphase_mod.f90	(revision 3833)
@@ -60,27 +60,30 @@
   !SAVE  ! note: occurs again in automatically generated code ...
 
-!  PUBLIC :: IERR_NAMES
- 
-! PUBLIC :: SPC_NAMES,EQN_NAMES,EQN_TAGS,REQ_HET,REQ_AEROSOL,REQ_PHOTRAT &
-!         ,REQ_MCFCT,IP_MAX,jname
-
+! Public variables
+  PUBLIC :: atol
   PUBLIC :: cs_mech
-  PUBLIC :: eqn_names, phot_names, spc_names
+  PUBLIC :: eqn_names
+  PUBLIC :: fakt
   PUBLIC :: nmaxfixsteps
-  PUBLIC :: atol, rtol
-  PUBLIC :: nspec, nreact
+  PUBLIC :: nphot
+  PUBLIC :: nreact
+  PUBLIC :: nspec
+  PUBLIC :: nvar
+  PUBLIC :: qvap
+  PUBLIC :: phot 
+  PUBLIC :: phot_names
+  PUBLIC :: rconst
+  PUBLIC :: rtol
+  PUBLIC :: spc_names
   PUBLIC :: temp
-  PUBLIC :: qvap
-  PUBLIC :: fakt
-  PUBLIC :: phot 
-  PUBLIC :: rconst
-  PUBLIC :: nvar
-  PUBLIC :: nphot
-  PUBLIC :: vl_dim                     ! PUBLIC to ebable other MODULEs to distiguish between scalar and vec
- 
-  PUBLIC :: initialize, integrate, update_rconst
+  PUBLIC :: vl_dim                     !< PUBLIC to enable other MODULEs to distiguish between scalar and vec
+ 
+! Public routines
   PUBLIC :: chem_gasphase_integrate
+  PUBLIC :: get_mechanism_name
+  PUBLIC :: initialize
   PUBLIC :: initialize_kpp_ctrl
-  PUBLIC :: get_mechanism_name
+  PUBLIC :: integrate
+  PUBLIC :: update_rconst
 
 ! END OF MODULE HEADER TEMPLATE
@@ -114,5 +117,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Parameters.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -221,5 +224,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Global.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -286,5 +289,5 @@
 ! 
 ! File                 : chem_gasphase_mod_JacobianSP.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -382,5 +385,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Monitor.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -545,5 +548,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Initialize.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -571,5 +574,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Integrator.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -629,5 +632,5 @@
 ! 
 ! File                 : chem_gasphase_mod_LinearAlgebra.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -656,5 +659,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Jacobian.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -683,5 +686,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Function.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -712,5 +715,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Rates.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -738,5 +741,5 @@
 ! 
 ! File                 : chem_gasphase_mod_Util.f90
-! Time                 : Wed Mar 27 09:51:33 2019
+! Time                 : Thu Mar 28 15:59:22 2019
 ! Working directory    : /home/forkel-r/palmstuff/work/trunk20190327/UTIL/chemistry/gasphase_preproc/tmp_kpp4palm
 ! Equation file        : chem_gasphase_mod.kpp
@@ -772,6 +775,8 @@
   INTEGER, PARAMETER, PUBLIC :: nkppctrl = 20
   !
-  INTEGER, DIMENSION(nkppctrl), PUBLIC     :: icntrl = 0
+  ! steering PARAMETERs for chemistry solver (see kpp domumentation)
+  INTEGER, DIMENSION(nkppctrl), PUBLIC      :: icntrl = 0
   REAL(dp), DIMENSION(nkppctrl), PUBLIC     :: rcntrl = 0.0_dp
+  ! t_steps: fixed time steps in vector mode
   REAL(dp), DIMENSION(nmaxfixsteps), PUBLIC :: t_steps = 0.0_dp
 