Index: /palm/trunk/SOURCE/gust_mod.f90
===================================================================
--- /palm/trunk/SOURCE/gust_mod.f90	(revision 3836)
+++ /palm/trunk/SOURCE/gust_mod.f90	(revision 3837)
@@ -85,4 +85,5 @@
        gust_header, &
        gust_actions, &
+       gust_prognostic_equations, &
        gust_swap_timelevel, &
        gust_3d_data_averaging, &
@@ -137,4 +138,9 @@
     END INTERFACE gust_actions
 
+    INTERFACE gust_prognostic_equations
+       MODULE PROCEDURE gust_prognostic_equations
+       MODULE PROCEDURE gust_prognostic_equations_ij
+    END INTERFACE gust_prognostic_equations
+
     INTERFACE gust_swap_timelevel
        MODULE PROCEDURE gust_swap_timelevel
@@ -380,4 +386,38 @@
 
     END SUBROUTINE gust_actions_ij
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Call for all grid points
+!------------------------------------------------------------------------------!
+    SUBROUTINE gust_prognostic_equations()
+
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = 1
+
+    END SUBROUTINE gust_prognostic_equations
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Call for grid point i,j
+!------------------------------------------------------------------------------!
+    SUBROUTINE gust_prognostic_equations_ij( i, j, i_omp_start, tn )
+
+
+       INTEGER(iwp), INTENT(IN) ::  i            !< grid index in x-direction
+       INTEGER(iwp), INTENT(IN) ::  j            !< grid index in y-direction
+       INTEGER(iwp), INTENT(IN) ::  i_omp_start  !< first loop index of i-loop in prognostic_equations
+       INTEGER(iwp), INTENT(IN) ::  tn           !< task number of openmp task
+
+!
+!--    Next line is just to avoid compiler warnings about unused variables. You may remove it.
+       IF ( dummy_logical )  idum = i + j + i_omp_start + tn
+
+    END SUBROUTINE gust_prognostic_equations_ij
 
 
Index: /palm/trunk/SOURCE/module_interface.f90
===================================================================
--- /palm/trunk/SOURCE/module_interface.f90	(revision 3836)
+++ /palm/trunk/SOURCE/module_interface.f90	(revision 3837)
@@ -185,4 +185,5 @@
                gust_header,                                                    &
                gust_actions,                                                   &
+               gust_prognostic_equations,                                      &
                gust_swap_timelevel,                                            &
                gust_3d_data_averaging,                                         &
@@ -372,4 +373,5 @@
        module_interface_header,                                                &
        module_interface_actions,                                               &
+       module_interface_prognostic_equations,                                  &
        module_interface_swap_timelevel,                                        &
        module_interface_3d_data_averaging,                                     &
@@ -432,4 +434,9 @@
        MODULE PROCEDURE module_interface_actions_ij
     END INTERFACE module_interface_actions
+
+    INTERFACE module_interface_prognostic_equations
+       MODULE PROCEDURE module_interface_prognostic_equations
+       MODULE PROCEDURE module_interface_prognostic_equations_ij
+    END INTERFACE module_interface_prognostic_equations
 
     INTERFACE module_interface_swap_timelevel
@@ -894,4 +901,38 @@
 ! Description:
 ! ------------
+!> Compute module-specific prognostic_equations (cache-optimized)
+!------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_prognostic_equations()
+
+
+    IF ( gust_module_enabled )  CALL gust_prognostic_equations()
+
+
+ END SUBROUTINE module_interface_prognostic_equations
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute module-specific prognostic_equations (vector-optimized)
+!------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_prognostic_equations_ij( i, j, i_omp_start, tn )
+
+
+    INTEGER(iwp), INTENT(IN) ::  i            !< grid index in x-direction
+    INTEGER(iwp), INTENT(IN) ::  j            !< grid index in y-direction
+    INTEGER(iwp), INTENT(IN) ::  i_omp_start  !< first loop index of i-loop in prognostic_equations
+    INTEGER(iwp), INTENT(IN) ::  tn           !< task number of openmp task
+
+
+    IF ( gust_module_enabled )  CALL gust_prognostic_equations( i, j, i_omp_start, tn )
+
+
+ END SUBROUTINE module_interface_prognostic_equations_ij
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Swap the timelevel pointers for module-specific arrays
 !------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3836)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3837)
@@ -432,5 +432,6 @@
 
     USE module_interface,                                                      &
-        ONLY:  module_interface_actions
+        ONLY:  module_interface_actions, &
+               module_interface_prognostic_equations
 
     USE ocean_mod,                                                             &
@@ -1420,4 +1421,7 @@
 !--       Calculate prognostic equations for turbulence closure
           CALL tcm_prognostic_equations( i, j, i_omp_start, tn )
+!
+!--       Calculate prognostic equations for all other modules
+          CALL module_interface_prognostic_equations( i, j, i_omp_start, tn )
 
 !
@@ -2642,4 +2646,7 @@
 !-- Calculate prognostic equations for turbulence closure
     CALL tcm_prognostic_equations()
+!
+!-- Calculate prognostic equations for all other modules
+    CALL module_interface_prognostic_equations()
 
 !